#include <iostream>
#include <cmath>
#include "point.h"

using namespace std;

void test2D() {
    Point2DInt p2_1;
    Point2DInt p2_2 {1.3, -5};//Hier Compiler-Warnung
    cout << "p2_1"  << p2_1 << endl;
    cout << "p2_2"  << p2_2 << endl;
    cout << boolalpha << (p2_1 == p2_2) << endl;
    p2_1 -= p2_1;
    p2_1 += {1, -5};
    cout << (p2_1 == p2_2) << endl;
    cout << (p2_1 != p2_2) << endl;
    cout << (p2_1 == p2_1) << endl;
    cout << 2*p2_1 << endl;
    cout << "length: " << sqrt(p2_1*p2_1) << endl;
}

void test3D() {
    Point<> p3_1;
    Point3D p3_2 {};
    Point3D p3_3 {1.2, -5.3, 10};
    Point3D p3_4 {-5.};
    Point3D p3_5 = -p3_3;
    cout << "p3_1 " << p3_1 << endl;
    cout << "p3_2 " << p3_2 << endl;
    cout << "p3_3 " << p3_3 << endl;
    cout << "p3_4 " << p3_4 << endl;
    cout << "p3_5 " << p3_5 << endl;
    cout << "-p3_5 " << -p3_5 << endl;
    p3_1 = {};
    p3_1 += {1.5, 2, 3};
    cout << "p3_1 " << p3_1 << endl;
    p3_1 += p3_4;
    cout << "p3_1 " << p3_1 << endl;
    p3_1 -= {3, -0.5};
    cout << "p3_1 " << p3_1 << endl;
    p3_1 = p3_3 + p3_4;
    cout << "p3_1 " << p3_1 << endl;
    p3_1 = Point3D{5, 6, 7} + p3_1;
    cout << "p3_1 " << p3_1 << endl;
    p3_1 = p3_1 - p3_1;
    cout << "p3_1 " << p3_1 << endl;
    cout << p3_3[1] << endl;
    p3_3[2] = -10.3;
    cout << "p3_3 " << p3_3 << endl;
}

int main()
{
    test2D();
    test3D();
    return 0;
}

